% Batch

clear all
close all


FlagVisu=0;
mode=1; % 1 : premier calcul, 2 : relancer une série en ayant changé les paramètres (ne vaut que pour la première échelles, les éventuelles autres sont faites en mode 2 bien sûr)

multiscale=0; % yes/no
list_regul=[100 1]; % si mode 2 et multiscale, la 1ère valeur est l'échelle d'initialisation
list_reguledge=[50 1];% si mode 2 et multiscale, la 1ère valeur est l'échelle d'initialisation
list_critconv=[1.e-5 1.e-5 1.e-5 1.e-5 1.e-5 1.e-5 1.e-5 1.e-5 1.e-5 1.e-5 1.e-5 1.e-5];

FileMask='';
RefMask=zeros(1,6);
PathName='/usrtmp/mathieu/tests_iris3/test_close2/Cam1/';
FileName1='Camera_No.1';
FileName3='.tif';
FileMesh='Mesh.mat';
ncar=6; % nombre de caractères dans le numéro de l'image


% Paramètres pour le premier calcul

Param.InterpMethod='*cubic';
%Param.InterpMethod='*linear';
Param.Itermin=5;
Param.Itermax=20;
Param.IterDamage=0;
Param.Young=1;
Param.nu=0.33;

Param.Lregul=5; % si multiéchelle, sans effet
Param.Lreguledge=2; % si multiéchelle, sans effet
Param.CvCriter=1.e-4; % si multiéchelle, sans effet

numimref=1; %numéro de l'image de référence
inum1=3; %première image déformée traitée pour la première échelle
inum2=500; %dernière image déformée
pas=1;%incrément de num d'image

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

time1=clock;
save('time1.mat','time1')
nbfic=['%0' num2str(ncar) 'g'];

if multiscale
	%
else
	list_regul=Param.Lregul;
	list_reguledge=Param.Lreguledge;
	list_critconv=Param.CvCriter;
end

limit=numel(list_regul);

if (mode==2)&&multiscale
limit=limit-1;
end

for kk=1

	if multiscale&&(mode==2)
	Param.Lregul=list_regul(kk+1);
	Param.Lreguledge=list_reguledge(kk+1);
	Param.CvCriter=list_critconv(kk+1);
	else
	Param.Lregul=list_regul(kk);
	Param.Lreguledge=list_reguledge(kk);
	Param.CvCriter=list_critconv(kk);
	end

	if (kk==2)&&(mode==1)
	    inum1=inum1-pas;
	end

	for ii=inum1:inum2

	    if kk==2
		numimref=imref(ii);
	    end

	    FileName21=num2str(numimref,nbfic);
	    FileName22=num2str(numimref,nbfic);
	    FileName23=num2str(ii-pas,nbfic);
	    FileNameRef=[PathName,FileName1,FileName21,FileName3];
	    FileNameDef=[PathName,FileName1,FileName22,FileName3];
	    if (mode==1)&&(kk==1)
	    	FileIniU=[PathName,FileName1,FileName21,'-',FileName1,FileName23,'-',num2str(list_regul(kk)),'-Mesh.mat']
	    elseif (mode==2)||(kk>1)
	    	FileIniU=[PathName,FileName1,FileName21,'-',FileName1,FileName22,'-',num2str(list_regul(kk)),'-Mesh.mat']
	    end

		%try
		    TestMain3(FileNameRef,FileNameDef,FileMask,FileMesh,FileIniU,FlagVisu,Param) 
		    if FlagVisu&(ii<inum2)
			pause
			close all
		    end
		%catch
			disp(' ')
			disp('No convergence or error : updating reference image')
			disp(' ')

		    numimref=ii-pas;
		    FileName21=num2str(numimref,nbfic);
		    FileName22=num2str(ii,nbfic);
		    FileName23=num2str(ii-pas,nbfic);
		    FileNameRef=[PathName,FileName1,FileName21,FileName3];
		    FileNameDef=[PathName,FileName1,FileName22,FileName3];
		    FileIniU=''; %%% Pas de fichier de départ, commencer de zéro
		    TestMain3(FileNameRef,FileNameDef,FileMask,FileMesh,FileIniU,FlagVisu,Param) 
		    if FlagVisu&(ii<inum2)
			pause
			close all
		    end

		%end

		imref(ii)=numimref;
	end

end




load time1
time2=clock;
minutes=time2(5)-time1(5);
if minutes<0
    minutes=minutes+60;
    heures=time2(4)-time1(4)-1;
else
    heures=time2(4)-time1(4);
end
if heures<0
    heures=heures+24;
end
unix('hostname > a.txt');
out = fopen ('a.txt','r');
hostname = fscanf(out,'%s');
eval(['! echo " '  sprintf('Calcul fini sur %s. Temps total : %ih %imin.',hostname,heures,minutes) '" | mail -s "Calcul fini" mathieu@lmt.ens-cachan.fr'])
