% Batch

clear all
close all

FlagVisu=0;
mode=1; % 1 : premier calcul, 2 : relancer une série en ayant changé les paramètres

FileMask='';
RefMask=zeros(1,6);
PathName='/usrtmp/mathieu/tests_iris3/test_close2/Cam2/';
FileName1='Camera_No.2';
FileName3='.tif';
FileMesh='Mesh.mat';
ncar=6; % nombre de caractères dans le numéro de l'image

Param.InterpMethod='*cubic';
%Param.InterpMethod='*linear';
Param.Itermin=5;
Param.Itermax=20;
Param.IterDamage=0;
Param.Lregul=5;
Param.Lreguledge=2;
Param.Young=1;
Param.nu=0.33;
Param.CvCriter=1.e-4;

numimref=1; %numéro de l'image de référence
inum1=3; %deuxième image déformée
inum2=300; %dernière image déformée
pas=1;%incrément de num d'image

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

time1=clock;
save('time1.mat','time1')
nbfic=['%0' num2str(ncar) 'g'];


for ii=inum1:inum2

    FileName21=num2str(numimref,nbfic);
    FileName22=num2str(ii,nbfic);
    FileName23=num2str(ii-pas,nbfic);
    FileNameRef=[PathName,FileName1,FileName21,FileName3];
    FileNameDef=[PathName,FileName1,FileName22,FileName3];
    if mode==1
    	FileIniU=[PathName,FileName1,FileName21,'-',FileName1,FileName23,'-Mesh-',num2str(Param.Lregul),'.mat'];
    elseif mode==2
    	FileIniU=[PathName,FileName1,FileName21,'-',FileName1,FileName22,'-Mesh-',num2str(Param.Lregul),'.mat'];
    end

	%try
	    TestMain3(FileNameRef,FileNameDef,FileMask,FileMesh,FileIniU,FlagVisu,Param) 
	    if FlagVisu&(ii<inum2)
		pause
		close all
	    end
	%catch
	%	disp(' ')
	%	disp('No convergence or error : updating reference image')
	%	disp(' ')
%
	%    numimref=ii-pas;
	%    FileName21=num2str(numimref,nbfic);
	%    FileName22=num2str(ii,nbfic);
	%    FileName23=num2str(ii-pas,nbfic);
	%    FileNameRef=[PathName,FileName1,FileName21,FileName3];
	%    FileNameDef=[PathName,FileName1,FileName22,FileName3];
	%    FileIniU=''; %%% Pas de fichier de départ, commencer de zéro
	%    TestMain3(FileNameRef,FileNameDef,FileMask,FileMesh,FileIniU,FlagVisu,Param) 
	%    if FlagVisu&(ii<inum2)
	%	pause
	%	close all
	%    end

	%end

	imref(ii)=numimref;
end


load time1
time2=clock;
minutes=time2(5)-time1(5);
if minutes<0
    minutes=minutes+60;
    heures=time2(4)-time1(4)-1;
else
    heures=time2(4)-time1(4);
end
if heures<0
    heures=heures+24;
end

duree(1,:)=time2-time1;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

time1=clock;
save('time1.mat','time1')
nbfic=['%0' num2str(ncar) 'g'];

Param.Lregul=1000;
Param.Lreguledge=1000;

for ii=inum1:inum2

    FileName21=num2str(numimref,nbfic);
    FileName22=num2str(ii,nbfic);
    FileName23=num2str(ii-pas,nbfic);
    FileNameRef=[PathName,FileName1,FileName21,FileName3];
    FileNameDef=[PathName,FileName1,FileName22,FileName3];
    if mode==1
    	FileIniU=[PathName,FileName1,FileName21,'-',FileName1,FileName23,'-Mesh-',num2str(Param.Lregul),'.mat'];
    elseif mode==2
    	FileIniU=[PathName,FileName1,FileName21,'-',FileName1,FileName22,'-Mesh-',num2str(Param.Lregul),'.mat'];
    end

	try
	    TestMain3(FileNameRef,FileNameDef,FileMask,FileMesh,FileIniU,FlagVisu,Param) 
	    if FlagVisu&(ii<inum2)
		pause
		close all
	    end
	catch
		disp(' ')
		disp('No convergence or error : updating reference image')
		disp(' ')

	    numimref=ii-pas;
	    FileName21=num2str(numimref,nbfic);
	    FileName22=num2str(ii,nbfic);
	    FileName23=num2str(ii-pas,nbfic);
	    FileNameRef=[PathName,FileName1,FileName21,FileName3];
	    FileNameDef=[PathName,FileName1,FileName22,FileName3];
	    FileIniU=''; %%% Pas de fichier de départ, commencer de zéro
	    TestMain3(FileNameRef,FileNameDef,FileMask,FileMesh,FileIniU,FlagVisu,Param) 
	    if FlagVisu&(ii<inum2)
		pause
		close all
	    end

	end

	imref(ii)=numimref;
end

load time1;
time2=clock;
duree(2,:)=time2-time1;
time1=clock;
save('time1.mat','time1')

return

mode=2;

Param.Lregul=1;
Param.Lreguledge=1;

for ii=inum1:inum2

    FileName21=num2str(numimref,nbfic);
    FileName22=num2str(ii,nbfic);
    FileName23=num2str(ii-pas,nbfic);
    FileNameRef=[PathName,FileName1,FileName21,FileName3];
    FileNameDef=[PathName,FileName1,FileName22,FileName3];
    if mode==1
    	FileIniU=[PathName,FileName1,FileName21,'-',FileName1,FileName23,'-Mesh.mat'];
    elseif mode==2
    	FileIniU=[PathName,FileName1,FileName21,'-',FileName1,FileName22,'-Mesh.mat'];
    end

	try
	    TestMain3(FileNameRef,FileNameDef,FileMask,FileMesh,FileIniU,FlagVisu,Param) 
	    if FlagVisu&(ii<inum2)
		pause
		close all
	    end
	catch
		disp(' ')
		disp('No convergence or error : updating reference image')
		disp(' ')

	    numimref=ii-pas;
	    FileName21=num2str(numimref,nbfic);
	    FileName22=num2str(ii,nbfic);
	    FileName23=num2str(ii-pas,nbfic);
	    FileNameRef=[PathName,FileName1,FileName21,FileName3];
	    FileNameDef=[PathName,FileName1,FileName22,FileName3];
	    FileIniU=''; %%% Pas de fichier de départ, commencer de zéro
	    TestMain3(FileNameRef,FileNameDef,FileMask,FileMesh,FileIniU,FlagVisu,Param) 
	    if FlagVisu&(ii<inum2)
		pause
		close all
	    end

	end

	imref(ii)=numimref;
end
load time1
time2=clock;
minutes=time2(5)-time1(5);
if minutes<0
    minutes=minutes+60;
    heures=time2(4)-time1(4)-1;
else
    heures=time2(4)-time1(4);
end
if heures<0
    heures=heures+24;
end
duree(3,:)=time2-time1;

save('duree.mat','duree')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

unix('hostname > a.txt');
out = fopen ('a.txt','r');
hostname = fscanf(out,'%s');
eval(['! echo " '  sprintf('Calcul fini sur %s. Temps total : %ih %imin.',hostname,heures,minutes) '" | mail -s "Calcul fini" mathieu@lmt.ens-cachan.fr'])
