%load('C:\Users\Stephane\Im_Data\HorsPlan2\Fire_test\IMG_5374-IMG_5443-Mesh.mat')

% hand determination of vanishing point of 5364: 1175, 7975 in ROI
FlagScale=1;
clear Pole;
if FlagScale
    Path1='C:\Users\Stephane\Im_Data\HorsPlan2\Scale\';
    nfil=3;
else
    Path1='C:\Users\Stephane\Im_Data\HorsPlan2\Fire_test\';
    nfil=75;
end
Z='';
for ifil=1:nfil
    % FileName=['IMG_5374-IMG_5',num2str(ifil+374,'%03g')];
    if FlagScale
        FileName=['IMG_5364-IMG_5',num2str(ifil+364,'%03g')];
    else
        FileName=['IMG_5374-IMG_5',num2str(ifil+374,'%03g')];
    end
    FullFileName=[Path1,FileName,'-Mesh.mat'];
    if size(dir(FullFileName),1)==0
        Pole(:,ifil)=nan(2,1);
    else       
        load(FullFileName);
        Ux=U(1:2:end);
        Uy=U(2:2:end);
        
        M=[Uy(:),-Ux(:)];
        S=[Uy(:).*X(:)-Ux(:).*Y(:)];
        Pol=M\S;
        Pole(:,ifil)=Pol*1000;
        %disp(sprintf('File %s',FileName))
        disp(sprintf('File %s   Pole %5.0f  %5.0f',FileName,Pole(:,ifil)))
    end
    % if isempty(Z)
    %     Z=Mesh.Znode;
    %     X=real(Z)/1000;
    %     Y=imag(Z)/1000;
    % end
    % figure
    % quiver(Y*1000,X*1000,Uy,Ux)
    % hold on
    % plot(Pole(2)*1000,Pole(1)*1000,'ro','MarkerFaceColor','r')
    %axis ij
    %axis image
    
    % Uref=X(:)-Pole(1);
    % Vref=Y(:)-Pole(2);
    % a=sqrt(Uref(:).^2+Vref(:).^2);
    % Uref=Uref./a;Vref=Vref./a;
    % quiver(Y*1000,X*1000,Vref,Uref,'r')
    %
    % Uref=X(:)-Pole(1);
    % Vref=Y(:)-Pole(2);
    % a=(Uref(:).^2+Vref(:).^2);
    % psi=(Ux(:).*Uref(:)+Uy(:).*Vref(:))./a;
    % psi=psi./(psi+1);
    %
    % M=[X(:),Y(:),ones(size(X(:)))];
    % sol=M\psi(:);
    % residual=norm(M*sol-psi)/norm(psi);
    % disp(sprintf('Residual = %5.2f %%',residual*100));
    % sol(4)=norm(sol(1:2));
    % sol(1)=sol(1)/sol(4);
    % sol(2)=sol(2)/sol(4);
    % sol(3)=sol(3)/sol(4);
    % Star=sol(1:2)*sol(3);
    % hold on
    % plot(Star(2)*1000,Star(1)*1000,'bo','MarkerFaceColor','b')
    % disp(sprintf('Vanishing point coordinates %5.0f  %5.0f',Star*1000))
end
if FlagScale
    save('ScalePole.mat','Pole');
else
    save('TestPole.mat','Pole');
end
clear Pole
figure
load('ScalePole.mat','Pole');
plot(Pole(2,:),Pole(1,:),'ro-','MarkerFaceColor','r')
clear Pole
hold on
load('TestPole.mat','Pole');
plot(Pole(2,:),Pole(1,:),'ko-')
clear Pole

figure
load('ScalePole.mat','Pole');
plot(Pole(1,:),'ro-','MarkerFaceColor','r')
clear Pole
hold on
load('TestPole.mat','Pole');
plot(5+[1:size(Pole,2)],Pole(1,:),'ko-')
clear Pole

figure
load('ScalePole.mat','Pole');
plot(Pole(2,:),'ro-','MarkerFaceColor','r')
clear Pole
hold on
load('TestPole.mat','Pole');
plot(5+[1:size(Pole,2)],Pole(2,:),'ko-')
clear Pole
