function  TriDICEdge

load('./TMP/Mesh.mat','TRI','Znode','NNodeIn','NNodeEdge');

Z=Znode(NNodeIn+1:end);

dZp=[Z(2:end);Z(1)]-Z;
dZm=[dZp(end);dZp(1:end-1)];
d2Z=imag(conj(dZp).*dZm);

ind=find(abs(d2Z)<.01);

ind1=[];
ind2=[];
kel=[];

for ii=1:length(ind)
    ij=ind(ii);
    ijp=mod(ij,NNodeEdge)+1;
    ijm=mod(ij+NNodeEdge-2,NNodeEdge)+1;
    ind1=cat(1,ind1,[2*ij-1+2*NNodeIn;2*ij-1+2*NNodeIn;2*ij-1+2*NNodeIn]);
    ind2=cat(1,ind2,[2*ijp-1+2*NNodeIn;2*ij-1+2*NNodeIn;2*ijm-1+2*NNodeIn]);
    kel=[kel;-1./abs(dZp(ij));1./abs(dZp(ij))+1./abs(dZp(ijm));-1./abs(dZp(ijm))];
    ind1=cat(1,ind1,[2*ij+2*NNodeIn;2*ij+2*NNodeIn;2*ij+2*NNodeIn]);
    ind2=cat(1,ind2,[2*ijp+2*NNodeIn;2*ij+2*NNodeIn;2*ijm+2*NNodeIn]);
    kel=[kel;-1./abs(dZp(ij));1./abs(dZp(ij))+1./abs(dZp(ijm));-1./abs(dZp(ijm))];
end

K=sparse(ind1,ind2,kel);
Kedge=K'*K;


save('./TMP/Edge','Kedge')



    



