function [NewJob,imdef]=Choose_Def(FlagBatch,NewJob,LastJob,WorkFile,im,Param,FlagVisu)

if FlagBatch==0
    filedefault=LastJob.Def;
    k=max(strfind(LastJob.Ref,'.'));
    Filter=['*',LastJob.Ref(k:end)];
    [FileName,PathName]=uigetfile(Filter,'Select a deformed image file',filedefault);
    FileNameDef=fullfile(PathName,FileName);
    FileNameDef=strrep(FileNameDef,'\','/');
    NewJob.Def=FileNameDef;
end

LastParam=Param;
Job=NewJob;
save(WorkFile.LastJob,'Job','LastParam');
disp(sprintf('Deformed image file  = %s',NewJob.Def));

imdef=ReadIm(NewJob.Def);
save(WorkFile.ImDef,'imdef');

if FlagVisu
    HandleFigDef=ShowIm(imdef,'Deformed Image');
    ROI=NewJob.ROI;
    HandleFigDiff=ShowIm(im-imdef(ROI(1):ROI(3),ROI(2):ROI(4)),'Initial difference','ROI',ROI);
    colormap(hot)
end
