clear all
close all


im=imread('C:/Im_data/Mesh/composite00.bmp');
im=double(im);
im=im(:,1:end-1);
figure
imagesc(im)
colormap(gray)
axis image

jm=im(150:250,200:300);
imagesc(jm)
axis image

figure
colormap(hot)
z=min(jm/110,1);
z0=z;
z0(end,:)=1;
z0(:,end)=1;
%% 
ell=10;
for ii=1:100
    maska=(abs(z-.5)<.499);
    f1(maska)=-sin(z(maska)*2*pi)/ell;
    f2=del2(z);
    z=z+.2*(f1+f2);
    z=min(z,1);
    z=max(z,0);
    z(1,:)=z0(1,:);
    z(:,1)=z0(:,1);
    z(end,:)=1;
    z(:,end)=1;  
    imagesc(z)
    axis image
    title(num2str(ii))
    pause(.1)
end

%% 









[Gy,Gx]=gradient(im);
G=sqrt(Gx.^2+Gy.^2);

figure
colormap(gray)
imagesc(G)
axis image

f=(im<55);
figure
colormap(gray)
imagesc(f)
axis image

nx=size(f,1);
ny=size(f,2);
g=5*ones(size(f));
for ii=1:20
g(2:nx-1,2:ny-1)=f(1:nx-2,2:ny-1)+f(2:nx-1,2:ny-1)+f(3:nx,2:ny-1)...
    +f(1:nx-2,3:ny)+f(2:nx-1,3:ny)+f(3:nx,3:ny)...
    +f(1:nx-2,1:ny-2)+f(2:nx-1,1:ny-2)+f(3:nx,1:ny-2);
f(g>6)=1;
f(g<5)=0;
sum(f(:))
% g=1-f;
% g(2:nx-1,2:ny-1)=g(3:nx,2:ny-1)&g(1:nx-2,2:ny-1)&g(2:nx-1,1:ny-2)&g(2:nx-1,3:ny); % 4 whites
% f=1-g;

% f(2:nx-1,2:ny-1)=f(3:nx,2:ny-1)&f(1:nx-2,2:ny-1)&f(2:nx-1,1:ny-2)&f(2:nx-1,3:ny); % 4 blacks

end
figure
colormap(gray)
imagesc(f)
axis image


g=zeros(size(f));
g(1,1)=1;
g(1,end)=1;
g(end,1)=1;
g(end,end)=1;

for ii=1:100
g(2:end,:)=g(2:end,:)|(f(2:end,:)&g(1:end-1,:));
g(1:end-1,:)=g(1:end-1,:)|(f(1:end-1,:)&g(2:end,:));
g(:,2:end)=g(:,2:end)|(f(:,2:end)&g(:,1:end-1));
g(:,1:end-1)=g(:,1:end-1)|(f(:,1:end-1)&g(:,2:end));
end

figure
imagesc(g)


