clear all;
close all;

n=256;
dmax=50; %distance max en pixels

im=zeros(n);
im(50,50:200)=1;
im(200,50:200)=1;
im(50:200,50)=1;
im(50:200,200)=1;

[Y,X]=meshgrid([0:n-1]/(n),[0:n-1]/(n));
R=min(X.^2,(1-X).^2)+min(Y.^2,(1-Y).^2);
R=min(R,(dmax/n)^2);
lR=log(R+1.e-6);
flR=fft2(lR);
fim=fft2(im);
jm=real(ifft2(flR.*fim));
km=jm-min(jm(:));
%km=km/max(km(:));

% figure
% imagesc(lR)
% colormap(hot)

% figure
% imagesc(jm)
% colormap(hot)

figure
imagesc(km)
colormap(hot)
colorbar
hold on
line([50,200,200,50,50],[50,50,200,200,50],'Color','w')

figure
surf(-km(128:end,:),'EdgeColor','none')
%caxis([0 1.2])
colormap(hot)
