clear all;
close all;

n=256;
dmax=20; %distance max en pixels

im=zeros(n);
im(50:200,50:200)=1;

[Y,X]=meshgrid([0:n-1]/(n),[0:n-1]/(n));
R=min(X.^2,(1-X).^2)+min(Y.^2,(1-Y).^2);
%R=max(1-R/(dmax/n)^2,0);
R=max(1-sqrt(R)/(dmax/n),0);

fR=fft2(R);
fR=fR/fR(1);
fim=fft2(im);
jm=real(ifft2(fR.*fim));

figure
colormap(hot)
imagesc(jm)
axis image 
colorbar

figure
plot(jm(128,:))

[gy,gx]=gradient(jm);
figure
imagesc(gx)
colormap hot
figure
plot(gx(:,128))
