function FileList=FindMeshFile(NewJob);

% returns a cell array "FileList" of Mesh corresponding to polygon ref 
% selected in NewJob

List=dir('TMP/Mesh*.mat');
Nfil=size(List,1);
if Nfil==0
    FileList={''};
    return
else
    for ii=1:Nfil
        load(['TMP/',List(ii).name])
        ind(ii)=isequal(Mesh.RefPoly,NewJob.RefPoly);
    end
    ind=logical(ind);
    FileList={List(ind).name};
    for ii=1:size(FileList,2)
        FileList{ii}=['TMP/',FileList{ii}];
    end
end


