function [T,W1,W2,W3]=Pixel2Tri(TRI,Znode,ROI)

Nelem=size(TRI,1);
T =zeros(ROI(3)-ROI(1)+1,ROI(4)-ROI(2)+1);
W1=zeros(ROI(3)-ROI(1)+1,ROI(4)-ROI(2)+1);
W2=zeros(ROI(3)-ROI(1)+1,ROI(4)-ROI(2)+1);
W3=zeros(ROI(3)-ROI(1)+1,ROI(4)-ROI(2)+1);

for ii=1:Nelem
    xmin=floor(min(real(Znode(TRI(ii,:)))));    
    xmax= ceil(max(real(Znode(TRI(ii,:)))));
    ymin=floor(min(imag(Znode(TRI(ii,:)))));    
    ymax= ceil(max(imag(Znode(TRI(ii,:)))));
    xmin=max(xmin,ROI(1));
    xmax=min(xmax,ROI(3));
    ymin=max(ymin,ROI(2));
    ymax=min(ymax,ROI(4));
    x=[xmin:xmax];
    y=[ymin:ymax];
    [X,Y]=meshgrid(x,y);
    IN=inpolygon(X,Y,real(Znode(TRI(ii,:))),imag(Znode(TRI(ii,:))));
    ind=find(IN);
    ix=X(ind)-ROI(1)+1;
    iy=Y(ind)-ROI(2)+1;
    indim=ix+(iy-1)*(ROI(3)-ROI(1)+1);
    A= [real(Znode(TRI(ii,1)))-real(Znode(TRI(ii,3))),...
        real(Znode(TRI(ii,2)))-real(Znode(TRI(ii,3)));...
        imag(Znode(TRI(ii,1)))-imag(Znode(TRI(ii,3))),...
        imag(Znode(TRI(ii,2)))-imag(Znode(TRI(ii,3)))];
    invA=inv(A);
    T(indim)=ii;
    X=X(ind)-real(Znode(TRI(ii,3)));
    Y=Y(ind)-imag(Znode(TRI(ii,3)));
    W=invA*[X';Y'];
    W1(indim)=W(1,:)';
    W2(indim)=W(2,:)';
    W3(indim)=1-W(1,:)'-W(2,:)';
end
    