clear all
close all
%FlagLoad=1;


%if FlagLoad
nfil=71;
Path2='C:\Users\Stephane\Im_Data\HorsPlan2\Fire_test\';
FileName20='IMG_5374-IMG_5';
FileName22='-Image.mat';
%
Path1='C:\Users\Stephane\Im_Data\HorsPlan2\Scale\';
FileName=[Path1,'IMG_5364-IMG_5367-Image.mat'];
DistanceRef=60;% 
load(FileName,'Uxpix','Uypix','coorx','coory','im1');
%
Uxref=Uxpix/DistanceRef;
Uyref=Uypix/DistanceRef;
norme=1./(Uxref.^2+Uyref.^2);
Uxref=Uxref.*norme;
Uyref=Uyref.*norme;
%
for ifil=1:nfil
    disp(sprintf('%3.0f / %3.0f',ifil,nfil))
    FileName21=num2str(374+ifil,'%03g');
    FileName=[Path2,FileName20,FileName21,FileName22];
    if size(dir(FileName),1)
        load(FileName,'Uxpix','Uypix')
        Uz(:,:,ifil)=Uxpix.*Uxref+Uypix.*Uyref;
        Flag(ifil)=1;
    else
        Flag(ifil)=0;
    end
end

Uzmx=max(Uz(:));
Uzmn=min(Uz(:));
ind=find(Flag);
nfil2=length(ind);
Uz=Uz(:,:,ind);
load('C:\Users\Stephane\Im_Data\HorsPlan2\SGRData.mat')
time=time(ind(:)+1);
fileno=374+ind(:);
Uzrange=[Uzmn Uzmx];
% save('FinalResult','time','fileno','Uz','coorx','coory','Uzrange',...
%     '-v7.3');
% else
%     load('FinalResult')
% end

nfil2=size(Uz,3);
for ifil=nfil2-9:nfil2
    hf=figure('Position',[23 54 842 617]);
    colormap(hot)
    %imagesc(coory,coorx,Uz(:,:,ifil),Uzrange)
    imagesc(coory,coorx,Uz(:,:,ifil))
    title(['U_z (mm) at time = ',num2str(time(ifil),'%5.2f'),' min.'])
    axis image
    colorbar
    drawnow
    filesave=[Path2,'Uz_5',num2str(fileno(ifil)),'.jpg'];
    saveas(hf,filesave)
    %F(ifil)=getframe;
end
%movie(F)
