function [NewJob,U]=SetInitialDisp(FlagBatch,WorkFile,NewJob,im,imdef,Param)


Flag.IniRBM=0;
if (isempty(NewJob.IniU))
    if (FlagBatch==0)
        answer = inputdlg('Use earlier computation as initial (0/1) ?','Initialization',1,{'0'});
        if strcmp(answer{1},'1')
            [FileIni,PathIni]=uigetfile('*.mat','Select result file',NewJob.Path);
            NewJob.IniU=fullfile(PathIni,FileIni); % contains Mesh and U
        else
            Flag.IniRBM=1;
        end
    else
        Flag.IniRBM=1;
    end
end
            
if Flag.IniRBM
    ROI=NewJob.ROI;
    lnx=2.^floor(log2(size(im,1)-1));
    lny=2.^floor(log2(size(im,2)-1));
    center=floor([(size(im,1)+1),(size(im,2)+1)]/2);
    imtmp=im(center(1)+[-lnx/2:lnx/2-1],center(2)+[-lny/2:lny/2-1]);
    jmtmp=imdef(center(1)+[-lnx/2:lnx/2-1]+ROI(1)-1,center(2)+[-lny/2:lny/2-1]+ROI(2)-1);
    fimtmp=fft2(imtmp);fimtmp(1)=0;
    fjmtmp=fft2(jmtmp);fjmtmp(1)=0;
    cor=fftshift(real(ifft2(fimtmp.*conj(fjmtmp))));
    [mx,ii]=max(cor(:));
    ix=mod(ii-1,lnx)+1;
    iy=(ii-ix)/lnx+1;
    ux0=ix-lnx/2-1;
    uy0=iy-lny/2-1;
    disp(sprintf('Initial displacement Ux = %g    Uy = %g',ux0,uy0));
    load(NewJob.Mesh)
    U=repmat(-[ux0;uy0],[1,Mesh.NNodeTot]);
    Ndof=2*Mesh.NNodeTot;
    U=reshape(U,[Ndof,1]);
else
    load(NewJob.IniU,'U');
end

LastParam=Param;
Job=NewJob;
save(WorkFile.LastJob,'Job','LastParam');
