function  Handle=ShowIm(im,Title,varargin);

%
% Possible options
% 'ROI'
% 'Colormap'  
% 'Position'
% 'Handle'

error(nargchk(2,10,nargin)); % 
narg=nargin-2;
ROI=[];
col='gray';
pos=[.15 .15 .75 .75];
handl='';
coorx=[1,size(im,1)];
coory=[1,size(im,2)];

while narg>0
    if strcmp(varargin{narg-1},'ROI')
        ROI=varargin{narg};
        coorx=[ROI(1),ROI(3)];
        coory=[ROI(2),ROI(4)];
        narg=narg-2;
    elseif strcmp(varargin{narg-1},'Colormap')
        col=varargin{narg};
        narg=narg-2;
    elseif strcmp(varargin{narg-1},'Position')
        pos=varargin{narg};
        narg=narg-2;
    elseif strcmp(varargin{narg-1},'Handle')
        handl=varargin{narg};
        narg=narg-2;
    end
end

if size(handl,1)>0
    figure(handl);
    Handle=handl;
else
    Handle=figure;
end
colormap(col)
imagesc(coory,coorx,im)
axis image
title(Title,'Interpreter','latex')
xlabel('$y$','Interpreter','latex')
ylabel('$x$','Interpreter','latex')
set(gca,'Position',pos);

drawnow