% TestRefine
clear all
close all

ResultFileName1='C:\Im_Data\Affilies\380000max-405000max-Mesh';
ResultFileName2='C:\Im_Data\Affilies\380000max-405000max-Image';
load(ResultFileName1)
load(ResultFileName2)

for iter=1:4

FigResid=figure;
colormap(hot)
imagesc(coory,coorx,Resid.*Mask)
caxis(150*[-1 1])
axis image
hold on
triplot(TRI,imag(Znode)+ROI(2)-1,real(Znode)+ROI(1)-1,'k')
xlabel('$y$','Interpreter','latex')
ylabel('$x$','Interpreter','latex')
title('Mesh')
drawnow


% define region

title('Choose Polygon') 
[y,x]=ginput;
if length(x)<3 
    break
end
line(y,x,'Color','w')
pause(1)

Region=x+i*y;
FlagPlot=1;
answer = inputdlg('Characteristic length ?','Input size',1);
d=str2num(answer{1});
MeshCharLength=[MeshCharLength,d0];
[TRI,Znode,NNodeIn,NNodeEdge]=RefineMesh(d,Znode,NNodeIn,NNodeEdge,Region,FlagPlot);

close(FigResid);

end
MeshCharLength=[30 20 7 4];
RefMesh=now;
load('./TMP/Polygon.mat','RefPoly')
save('./TMP/Mesh.mat','RefPoly','RefMesh','TRI','Znode','NNodeIn','NNodeEdge','MeshCharLength');



