function     S=TriDICSecond(Resid)

load('./TMP/Mesh.mat','TRI','Znode','NNodeIn','NNodeEdge');
load('./TMP/ImMesh','T','W1','W2','W3');
load('./TMP/Psi','Gx1','Gy1','Gx2','Gy2','Gx3','Gy3')
[nx,ny]=size(Resid);
Nelem=size(TRI,1);
Ndof=2*(NNodeIn+NNodeEdge);
S=zeros(Ndof,1);

for ii=1:Nelem
    iinode=TRI(ii,:);
    xmin=floor(min(real(Znode(iinode))));
    xmax=floor(max(real(Znode(iinode))));
    ymin=ceil(min(imag(Znode(iinode))));
    ymax=ceil(max(imag(Znode(iinode))));
    x=[xmin:xmax];
    y=[ymin:ymax];
    [Y,X]=meshgrid(y,x);
    IN=inpolygon(Y,X,imag(Znode(iinode)),real(Znode(iinode)));
    ind=find(IN);
    ix=X(ind);
    iy=Y(ind);
    indim=ix+(iy-1)*nx;
    idof=[2*iinode(1)-1,2*iinode(1),2*iinode(2)-1,2*iinode(2),2*iinode(3)-1,2*iinode(3)];
    f(1)=sum(Gx1(indim).*Resid(indim));
    f(2)=sum(Gy1(indim).*Resid(indim));
    f(3)=sum(Gx2(indim).*Resid(indim));
    f(4)=sum(Gy2(indim).*Resid(indim));
    f(5)=sum(Gx3(indim).*Resid(indim));
    f(6)=sum(Gy3(indim).*Resid(indim));
    for ij=1:6
        S(idof(ij))=S(idof(ij))+f(ij);
    end
end      


